;;
;; GgrTF::ProtTracker - Party-wide prot tracker
;; (C) Copyright 2007-2008 Matti Hmlinen (Ggr) based on ideas by Aloysha
;;
;; This file (triggerset) is Free Software distributed under
;; GNU General Public License version 2.
;;
;; NOTICE! This file requires GgrTF (version 0.6.2 or later) to be loaded.
;;
/loaded GgrTF::ProtTracker
/set gmodule=ProtTracker

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Bindings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; The triggers for 'tug' are commented out. If you want to use them,
; copy the code into your tfrc and uncomment it.

;/def -i -F -p9999 -mregexp -t"^([A-Z][a-z]+) tugs eagerly on your sleeve.$" gpprot_tug1 = /eval /pprots @@emoteto %{P1}
;/def -i -F -p9999 -msimple -t"You tug eagerly on your own sleeve." gpprot_tug2 = /pprots @@emote


/prdefgbind -s"pprots" -c"/pprots"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main functions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/set lst_pprots=
/set lst_members=

;; The reason we have several triggers with complex patterns here is
;; because of TF's apparent  bug(s) in the regexp handling and TF4's
;; somewhat inferior support for regexp options.
;;
/def -p9999 -F -mregexp -t"^([A-Z][a-z]+) .(party|report).: +[(<>]? *([A-Za-z _-]+) *[>)]? (on|\+on\+|\(on\)|\[On\]|\[ON\]|up|active|activat|ON|UP|ACTIVE|ACTIVAT|On|Up|Active|Activat|Renewed|refresh)" gpprot_on1 =\
	/test gpprot_on({P1},{P3})

/def -p9999 -F -mregexp -t"^([A-Z][a-z]+) .(party|report).: +[(<>]? *([A-Za-z _-]+) *[>)]? (off|\-off\-|OFF|Off|\(off\)|\[Off\]|\[OFF\]|DOWN|Down|down|Expires|Expired|expires|expired|gone|Gone|was destroyed)" gpprot_off1 =\
	/test gpprot_off({P1},{P3})

/def -p9999 -F -mregexp -t"^([A-Z][a-z]+) .(party|report).: - ([A-Za-z _-]+) (UP|up|Up)" gpprot_on2 =\
	/test gpprot_on({P1},{P3})

/def -p9999 -F -mregexp -t"^([A-Z][a-z]+) .(party|report).: - ([A-Za-z _-]+) (DOWN|down|Down)" gpprot_off2 =\
	/test gpprot_off({P1},{P3})

/def -p9999 -F -mregexp -t"^([A-Z][a-z]+) .(party|report).: \[ ([A-Za-z _-]+) (UP|up|Up|active)" gpprot_on3 =\
	/test gpprot_on({P1},{P3})

/def -p9999 -F -mregexp -t"^([A-Z][a-z]+) .(party|report).: \[ ([A-Za-z _-]+) (DOWN|down|Down)" gpprot_off3 =\
	/test gpprot_off({P1},{P3})


/def -i gpprot_on =\
	/let _pname=$[gpprot_getn({2})]%;\
	/if (_pname!~"")\
		/test prlist_insert("lst_members",{1})%;\
		/set pprot_%{1}_%{_pname}=1%;\
		/set pprot_%{1}_%{_pname}_t=$[time()]%;\
	/endif

/def -i gpprot_off =\
	/let _pname=$[gpprot_getn({2})]%;\
	/if (_pname!~"")\
		/set pprot_%{1}_%{_pname}=0%;\
		/set pprot_%{1}_%{_pname}_t=0%;\
	/endif


/def -i prdefpartyprot =\
	/if (!getopts("i:n:A:m:","")) /gerror Invalid prot tracker definition!%;/break%;/endif%;\
	/set lst_pprots=%{lst_pprots} %{opt_i}%;\
	/set pprot_%{opt_i}_n=%{opt_n}%;\
	/set pprot_%{opt_i}_A=$[tolower(opt_A)]%;\
	/if (opt_m > 0)\
		/set pprot_%{opt_i}_m=%{opt_m}%;\
	/else \
		/set pprot_%{opt_i}_m=3600%;\
	/endif


/def -i gpprot_getn_do =\
	/while ({#})\
		/eval /set _pprot_tz=^($$[pprot_%{1}_A])$$$%;\
		/if (regmatch(_pprot_tz,_pprot_fs)) /return {1}%;/endif%;\
		/shift%;\
	/done%;\
	/return ""

/def -i gpprot_getn =\
	/set _pprot_fs=$[tolower({*})]%;\
	/gpprot_getn_do %{lst_pprots}


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/def -i gpprots_clear_member =\
	/let _zplr=%{1}%;/shift%;\
	/while ({#})\
		/eval /unset pprot_%{_zplr}_%{1}%;\
		/eval /unset pprot_%{_zplr}_%{1}_t%;\
		/shift%;\
	/done

/def -i gpprots_clear =\
	/while ({#})\
		/gpprots_clear_member %{1} %{lst_pprots}%;\
		/shift%;\
	/done

/def -i cpprots =\
	/msq @{BCgreen}NOTICE!@{n} @{BCwhite}Clearing all tracked prots!@{n}%;\
	/gpprots_clear %{lst_members}


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/def -i gpprots_update_member =\
	/let _zplr=%{1}%;/shift%;\
	/while ({#})\
		/eval /set _zta=$$[pprot_%{_zplr}_%{1}]%;\
		/eval /set _ztt=$$[pprot_%{_zplr}_%{1}_t]%;\
		/eval /set _ztm=$$[pprot_%{1}_m]%;\
		/if (_zta > 0)\
			/if (_ztm > 0 & (time() - _ztt) >= (_ztm + 10))\
				/set pprot_%{_zplr}_%{1}=0%;\
				/msq PPROTTER: %{_zplr} -> %{1} OFF! @{BCred}AUTO@{n}%;\
			/else \
				/test prlist_insert("lst_pactive",{1})%;\
			/endif%;\
		/endif%;\
		/shift%;\
	/done

/def -i gpprots_update_active =\
	/set lst_pactive=%;\
	/while ({#})\
		/gpprots_update_member %{1} %{lst_pprots}%;\
		/shift%;\
	/done
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/def -i prgetstimeclock =\
        /if ({1} >= 0)\
                /let _jtime=$[trunc(time()-{1})]%;\
                /let _jtimeh=$[_jtime/3600]%;\
                /let _jtimeq=$[mod(_jtime,3600)]%;\
		/let _jtimem=$[_jtimeq/60]%;\
		/let _jtimes=$[mod(_jtimeq,60)]%;\
                /if (_jtimeh > 0)\
                        /let _jstr=%{_jtimeh}:%;\
                /else \
                        /let _jstr=%;\
                /endif%;\
		/if (_jtimes < 10)\
			/let _jtimespre=0%;\
		/else \
			/let _jtimespre=%;\
		/endif%;\
                /let _jstr=%{_jstr}$[_jtimeq/60]:%{_jtimespre}$[mod(_jtimeq,60)]%;\
                /return _jstr%;\
        /else \
                /return ""%;\
        /endif

/def -i gpprots_print_header =\
	/let _pprot_nam=%;\
	/set _pprot_div=%;\
	/while ({#})\
		/eval /set _qtmw=$$[pprot_%{1}_n]%;\
		/let _pprot_nam=%{_pprot_nam}%{_pprot_col_name}$[pad(_qtmw,5)]%{_pprot_col_n}|%;\
		/set _pprot_div=%{_pprot_div}-----+%;\
		/shift%;\
	/done%;\
	/eval %{_pprot_cmd} .------------+%%{_pprot_div}%;\
	/eval %{_pprot_cmd} |            |%%{_pprot_nam}%;\
	/eval %{_pprot_cmd} +------------+%%{_pprot_div}
	

/def -i gpprots_print_player =\
	/let _zplr=%{1}%;/shift%;\
	/let _zsp=|%{_pprot_col_pname}$[pad(_zplr,-12)]%{_pprot_col_n}|%;\
	/while ({#})\
		/eval /set _qtm=$$[pprot_%{_zplr}_%{1}]%;\
		/eval /set _qtmt=$$[pprot_%{_zplr}_%{1}_t]%;\
		/if (_qtm > 0)\
			/let _tst=$[prgetstimeclock(_qtmt)]%;\
		/else \
			/let _tst=%;\
		/endif%;\
		/let _zsp=%{_zsp}$[pad(_tst,5)]|%;\
		/shift%;\
	/done%;\
	/eval %{_pprot_cmd} %%{_zsp}


/def -i gpprots_print_members =\
	/while ({#})\
		/gpprots_print_player %{1} %{lst_pactive}%;\
		/shift%;\
	/done


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Show prots
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/def -i pprots =\
	/if ({#} > 0)\
		/set _pprot_cmd=%{*}%;\
		/set _pprot_col_n=%;\
		/set _pprot_col_name=%;\
		/set _pprot_col_pname=%;\
	/else \
		/set _pprot_cmd=/echo -p%;\
		/set _pprot_col_n=@{n}%;\
		/set _pprot_col_name=@{BCwhite}%;\
		/set _pprot_col_pname=@{Cgreen}%;\
	/endif%;\
	/gpprots_update_active %{gparty_members}%;\
	/if (gparty_members=~"" | lst_pactive=~"")\
		/eval %{_pprot_cmd} %{_pprot_col_name}No party prots tracked%{_pprot_col_n}.%;\
	/else \
		/gpprots_print_header %{lst_pactive}%;\
		/gpprots_print_members %{gparty_members}%;\
		/eval %{_pprot_cmd} `------------+%{_pprot_div}%;\
	/endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Define prots and patterns
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Misc
/prdefpartyprot -i"unstun"	-n"Uns"		-A"Unstun|uns"
/prdefpartyprot -i"hw"		-n"HW"		-A"heavy weight|heavyweight|hw"
/prdefpartyprot -i"unp"		-n"Unp"		-A"Unpain|unp" 			-m900
/prdefpartyprot -i"pfg"		-n"PfG"		-A"protection from good|pfg"	-m1200
/prdefpartyprot -i"flex"	-n"Flex"	-A"flex shield|flex"
/prdefpartyprot -i"suppr"	-n"Suppr" 	-A"suppress magic|magic suppression|suppress"

;; Psionicist
/prdefpartyprot -i"fsh"		-n"FSh"		-A"Force Shield|fsh|fshield"	-m1800

;; Bard
/prdefpartyprot -i"warez"	-n"WarEs"	-A"War Ens[ae]mble|warez|war"	-m1000
/prdefpartyprot -i"mel"		-n"EMelo"	-A"Embracing melody|melodical embracement|melody"

;; Conjurer
/prdefpartyprot -i"aoa"		-n"AoA"		-A"Armour of Aether|AoA|aether armour|Armor of Aether|GPhys"
/prdefpartyprot -i"macid"	-n"MAcid"	-A"Acid Shield|GAcid"		-m1000
/prdefpartyprot -i"mpois"	-n"MPois"	-A"Shield of detoxification|poison prot|detox|GPoison"		-m1000
/prdefpartyprot -i"melec"	-n"MElec"	-A"Lighti?ning Shield|GElec"	-m1000
/prdefpartyprot -i"masph"	-n"MAsph"	-A"Aura of Wind|GAsph"		-m1000
/prdefpartyprot -i"mfire"	-n"MFire"	-A"Flame Shield|GFire"		-m1000
/prdefpartyprot -i"mmana"	-n"MMana"	-A"Repulsor Aura|GMana"		-m1000
/prdefpartyprot -i"mpsi"	-n"MPsi"	-A"Psionic Phalanx"		-m1000
/prdefpartyprot -i"mcold"	-n"MCold"	-A"Frost Shield|GCold"		-m1000

/prdefpartyprot -i"fabs"	-n"Fabs"	-A"Force Absorption|fabs|force absorbsion" -m1000
/prdefpartyprot -i"sop"		-n"SoP"		-A"Shield of protection|sop"	-m450
;/prdefpartyprot -i"displ"	-n"Displ"	-A"Displacement|blur image"	-m1000
/prdefpartyprot -i"rdisp"	-n"RDisp"	-A"Resist Dispel"		-m200

;; Evil priest
/prdefpartyprot -i"aoh"		-n"AoH"		-A"aura of hate|aoh"

;; Templar
/prdefpartyprot -i"sof"		-n"SoF"		-A"shield of faith|sof"

;; Nun
/prdefpartyprot -i"sshield"	-n"SShld" 	-A"soul shield|soul_shield|soulshield" -m900
/prdefpartyprot -i"pfe"		-n"PfE" 	-A"protection from evil|pfe"	-m1200
/prdefpartyprot -i"hprot"	-n"HProt" 	-A"heavenly protection|hprot"	-m900
